//package com.cultural.heritage.service.wxpay.impl;
//
//
//import cn.binarywang.wx.miniapp.api.WxMaMsgService;
//import cn.binarywang.wx.miniapp.api.WxMaService;
//import cn.binarywang.wx.miniapp.bean.WxMaSubscribeMessage;
//import cn.hutool.core.util.RandomUtil;
//import com.cultural.heritage.common.ErrorCode;
//import com.cultural.heritage.config.WxOpenConfig;
//import com.cultural.heritage.config.WxPayConfig;
//import com.cultural.heritage.exception.BusinessException;
//import com.cultural.heritage.model.entity.Order;
//import com.cultural.heritage.service.order.OrderService;
//import com.cultural.heritage.service.wxpay.WeChatService;
//import com.wechat.pay.java.core.notification.NotificationParser;
//import com.wechat.pay.java.core.notification.RequestParam;
//import com.wechat.pay.java.service.payments.jsapi.model.Amount;
//import com.wechat.pay.java.service.payments.jsapi.model.Payer;
//import com.wechat.pay.java.service.payments.jsapi.model.PrepayRequest;
//import com.wechat.pay.java.service.payments.jsapi.model.PrepayWithRequestPaymentResponse;
//import com.wechat.pay.java.service.payments.model.Transaction;
//import com.wechat.pay.java.service.refund.model.AmountReq;
//import com.wechat.pay.java.service.refund.model.CreateRequest;
//import com.wechat.pay.java.service.refund.model.Refund;
//import com.wechat.pay.java.service.refund.model.RefundNotification;
//import jakarta.annotation.Resource;
//import jakarta.servlet.http.HttpServletRequest;
//import lombok.SneakyThrows;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.stereotype.Service;
//import org.springframework.transaction.annotation.Transactional;
//
//import java.io.BufferedReader;
//import java.io.IOException;
//import java.math.BigDecimal;
//import java.time.LocalDate;
//import java.time.LocalDateTime;
//import java.time.LocalTime;
//import java.util.ArrayList;
//import java.util.List;
//
///**
// * @author 玄德
// */
//@Slf4j
//@Service
//public class WeChatServiceImpl implements WeChatService {
//
//    @Resource
//    private WxPayConfig wxPayConfig;
//
//    @Resource
//    private WxOpenConfig wxOpenConfig;
//
//    @Resource
//    private OrderService ordersService;
//
//    /**
//     * 请求参数
//     */
//    public static RequestParam requestParam = null;
//
//    @Override
//    @Transactional(rollbackFor = Exception.class)
//    public synchronized PrepayWithRequestPaymentResponse createPayment(String orderId, String miniOpenId, BigDecimal amount) {
//        // request.setXxx(val)设置所需参数，具体参数可见Request定义
//        PrepayRequest request = new PrepayRequest();
//        // 金额
//        Amount WxAmount = new Amount();
//        WxAmount.setTotal(amount.movePointRight(2).intValue());
//        WxAmount.setCurrency("CNY");
//        request.setAmount(WxAmount);
//        // 公众号id
//        request.setAppid(wxPayConfig.getAppId());
//        // 商户号
//        request.setMchid(wxPayConfig.getMerchantId());
//        // 支付者信息
//        Payer payer = new Payer();
//        payer.setOpenid(miniOpenId);
//        request.setPayer(payer);
//        // 描述
//        request.setDescription("订单号：" + orderId);
//        // 微信回调地址
//        request.setNotifyUrl(wxPayConfig.getNotifyUrl() + "/api/wechat/payment/callback");
//        // 商户订单号
//        request.setOutTradeNo(RandomUtil.randomNumbers(12));
//        //返回数据，前端调起支付
//        return wxPayConfig.getJsapiServiceExtension().prepayWithRequestPayment(request);
//    }
//
//    @Override
//    public Transaction getTransactionInfo(HttpServletRequest request) {
//        NotificationParser notificationParser = getNotificationParser(request);
//        return notificationParser.parse(requestParam, Transaction.class);
//    }
//
//    @Override
//    @Transactional(rollbackFor = Exception.class)
//    public synchronized boolean paymentCallback(Transaction transaction) throws IOException {
//        System.out.println("---------------------------微信支付回调（开始）-------------------------------");
//        // 获取订单信息
//        String orderIdByString = transaction.getOutTradeNo();
//        Order order = ordersService.getById(orderIdByString);
//        if (order == null) {
//            log.error("订单不存在");
//            throw new BusinessException(ErrorCode.NOT_FOUND_ERROR, "订单不存在，订单号：" + transaction.getOutTradeNo());
//        }
//        // 生成取餐码
//        // 获取当日的日期
//        LocalDate today = LocalDate.now();
//        // 获取当日的 00:00 时间
//        LocalDateTime startTime = today.atStartOfDay();
//        // 获取当日的 23:59 时间
//        LocalDateTime endTime = today.atTime(LocalTime.MAX);
////        // 生成取餐码
////        QueryWrapper<Orders> queryWrapper = new QueryWrapper<>();
////        queryWrapper.eq("businessId", order.getBusinessId());
////        queryWrapper.between("createTime", startTime, endTime);
////        queryWrapper.in("state", 1, 2);
////        long count = ordersService.count(queryWrapper);
////        String pickupCode = String.format("%04d", count + 1);
////        // 修改订单信息
////        order.setState(1);
////        order.setPickupCode(pickupCode);
////        Date date = new Date();
////        order.setUpdateTime(date);
////        boolean update = ordersService.updateById(order);
////        ThrowUtils.throwIf(!update, ErrorCode.OPERATION_ERROR, "修改订单状态失败");
////        // 通知商家新订单
////        Business business = businessService.getById(order.getBusinessId());
////        Long userId = order.getUserId();
////        Long businessId = business.getUserId();
////        MessageVO messageVO = new MessageVO();
////        messageVO.setType(1);
////        messageVO.setUserId(userId);
////        messageVO.setToUserId(businessId);
////        messageVO.setContent(orderIdByString);
////        String message = JSONUtil.toJsonStr(messageVO);
////        // 通知商家新订单
////        webSocketServer.onMessage(message);
//        System.out.println("---------------------------微信支付回调（结束）-------------------------------");
//        return true;
//    }
//
//    @Override
//    public Refund refundPayment(String orderId, BigDecimal amount) {
//        // 退款请求
//        CreateRequest createRequest = new CreateRequest();
//        // 商户订单号
//        createRequest.setOutTradeNo(orderId);
//        // 商户退款单号
//        createRequest.setOutRefundNo(orderId);
//        // 退款结果回调
//        createRequest.setNotifyUrl(wxPayConfig.getNotifyUrl() + "/api/wechat/refund/callback");
//        // 退款金额
//        AmountReq amountReq = new AmountReq();
//        long refundAmount = amount.movePointRight(2).intValue();
//        amountReq.setRefund(refundAmount);
//        amountReq.setTotal(refundAmount);
//        amountReq.setCurrency("CNY");
//        createRequest.setAmount(amountReq);
//        // 申请退款
//        System.out.println("退款请求：" + createRequest);
//        Refund refund = wxPayConfig.getRefundService().create(createRequest);
//        System.out.println("退款申请结果：" + refund);
//        return refund;
//    }
//
//    @Override
//    public RefundNotification getRefundInfo(HttpServletRequest request) {
//        NotificationParser notificationParser = getNotificationParser(request);
//        return notificationParser.parse(requestParam, RefundNotification.class);
//    }
//
//    @Override
//    @Transactional(rollbackFor = Exception.class)
//    public synchronized boolean refundCallback(RefundNotification refundNotification) {
//        System.out.println("---------------------------微信退款回调（开始）-------------------------------");
//        // 获取订单信息
//        String orderIdByString = refundNotification.getOutTradeNo();
//        Order order = ordersService.getById(orderIdByString);
//        // 修改订单信息
//        order.setOrderStatus("已退款");
//        ordersService.updateById(order);
//        System.out.println("---------------------------微信退款回调（结束）-------------------------------");
//        return true;
//    }
//
//    @Override
//    public boolean sendSubscribeMessage(String openid, String templateId) {
//        try {
//            // 获取小程序对象
//            WxMaService wxMaService = wxOpenConfig.getWxMaService();
//            // 获取消息接口
//            WxMaMsgService msgService = wxMaService.getMsgService();
//            // 构建订阅消息体
//            WxMaSubscribeMessage wxMaSubscribeMessage = new WxMaSubscribeMessage();
//            wxMaSubscribeMessage.setToUser(openid);
//            wxMaSubscribeMessage.setTemplateId(templateId);
//            List<WxMaSubscribeMessage.MsgData> msgDataList = getMsgData();
//            wxMaSubscribeMessage.setData(msgDataList);
//            // 发送消息
//            msgService.sendSubscribeMsg(wxMaSubscribeMessage);
//            return true;
//        } catch (Exception e) {
//            log.error("发送订阅消息失败：", e);
//            throw new BusinessException(ErrorCode.SYSTEM_ERROR, "发送订阅消息失败");
//        }
//    }
//
//    /**
//     * 提取消息数据
//     */
//    private static List<WxMaSubscribeMessage.MsgData> getMsgData() {
//        List<WxMaSubscribeMessage.MsgData> msgDataList = new ArrayList<>();
//        String[][] dataItems = {
//                {"thing1", "新订单"},
//                {"phrase2", "已支付"},
//                {"amount3", "666"},
//                {"thing10", "666666"},
//                {"time8", "2019-12-18 12:12:12"}
//        };
//        for (String[] item : dataItems) {
//            WxMaSubscribeMessage.MsgData msgData = new WxMaSubscribeMessage.MsgData();
//            msgData.setName(item[0]);
//            msgData.setValue(item[1]);
//            msgDataList.add(msgData);
//        }
//        return msgDataList;
//    }
//
//    /**
//     * 根据微信官方发送的请求获取信息
//     */
//    @SneakyThrows
//    public NotificationParser getNotificationParser(HttpServletRequest request) {
//        System.out.println("---------------------------获取信息-------------------------------");
//        // 获取RSA配置
//        NotificationParser notificationParser = new NotificationParser(wxPayConfig.getRSAConfig());
//        // 构建请求
//        StringBuilder bodyBuilder = new StringBuilder();
//        BufferedReader reader = request.getReader();
//        String line;
//        while ((line = reader.readLine()) != null) {
//            bodyBuilder.append(line);
//        }
//        String body = bodyBuilder.toString();
//        String timestamp = request.getHeader("Wechatpay-Timestamp");
//        String nonce = request.getHeader("Wechatpay-Nonce");
//        String signature = request.getHeader("Wechatpay-Signature");
//        String singType = request.getHeader("Wechatpay-Signature-Type");
//        String wechatPayCertificateSerialNumber = request.getHeader("Wechatpay-Serial");
//        requestParam = new RequestParam.Builder()
//                .serialNumber(wechatPayCertificateSerialNumber)
//                .nonce(nonce)
//                .signature(signature)
//                .timestamp(timestamp)
//                .signType(singType)
//                .body(body)
//                .build();
//        System.out.println(requestParam.toString());
//        System.out.println("---------------------------信息获取完毕-------------------------------");
//        return notificationParser;
//    }
//}
